/*
** Base64.c - part of GrabURL 2.0
** Copyright (C) 1996-97 Serge Emond
**
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU General Public License
** as published by the Free Software Foundation; either version 2
** of the License, or (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <stdlib.h>
#include <string.h>
#include "libgurl.h"
#include "Base64.h"

char base64table[65] = "ABCDEFGHIJKLMNOPQRSTUVWXYZ" \
                       "abcdefghijklmnopqrstuvwxyz" \
                       "0123456789+/";

char *EnBaseString(char *str)
{
	int i, c1, c2, c3, wrote;
	char *to;
	
	if (strlen(str) > MAXPWLENGTH)
		return(0);

	to = (char *)gmalloc(MAXBASELENGTH);
	
	c1=-1;c2=-1;c3=-1;wrote=0;
	
	for (i=0; (c3=(int)str[i]); i++) {
	  if (c1 < 0)
		c1 = c3;
	  else if (c2 < 0)
		c2 = c3;
	  else {
		EnBase64(to+(wrote*4), c1, c2, c3);
		c1=-1;c2=-1;c3=-1;
		wrote++;
	  }
	}
	EnBase64(to+(wrote*4), c1, c2, -1);
	return(to);
}

#ifndef UBYTE
#define UBYTE unsigned char
#endif

void EnBase64(three, c1, c2, c3)
char *three;
int c1, c2, c3;
{
	if (c1 < 0)
		return;

	three[0] = (UBYTE) base64table[c1 >> 2];
	if (c2 < 0)
		three[1] = (UBYTE) base64table[(c1 & 3) << 4];
	else
		three[1] = (UBYTE) base64table[((c1 & 3) << 4) + (c2 >> 4)];

	if (c2 < 0)
		three[2] = (UBYTE) '=';
	else if (c3 < 0)
		three[2] = (UBYTE) base64table[(c2 & 15) << 2];
	else
		three[2] = (UBYTE) base64table[((c2 & 15) << 2) + (c3 >> 6)];

	if (c3 < 0)
		three[3] = (UBYTE) '=';
	else
		three[3] = (UBYTE) base64table[c3 & 63];
}
