/*
** config_glob.c - part of GrabURL 2.0
** Copyright (C) 1996-97 Serge Emond
**
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU General Public License
** as published by the Free Software Foundation; either version 2
** of the License, or (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include "config.h"
#include "config_scan.h"
#include "log.h"
#include "http.h"

struct Scan_Cfg scan_cfg;

struct cfg_Section cfg_sections[] = {
  { "http" },
  { "scan" },
  { NULL }
};

struct cfg_InitConfig cfg_init[] = {
  { cfg_global_init },
  { cfg_scan_init },
  { NULL }
};

struct cfg_Args cfg_args[] = {
  { rargs_global },
  { rargs_scan },
  { NULL }
};

struct cfg_PostConfig cfg_post[] = {
  { cfg_global_post },
  { HTTP_PostConfig },
  { NULL }
};

/* Tag, tag length, function, section */
struct cfg_DoLine cfg_linecmds[] = {
  { "include",		7,	cfg_cmd_include,	       	0 },
  { "delay",		5,	cfg_cmd_delay,		       	0 },
  { "saveroot",		8,	cfg_cmd_saveroot,	       	0 },
  { "dirmode",		7,	cfg_cmd_dirmode,	       	0 },
  { "filemode",		8,	cfg_cmd_filemode,	       	0 },
  { "translate",	9,	cfg_cmd_translate,	       	0 },
  { "retry",		5,	cfg_cmd_retry,		       	0 },
  { "scan",	    	4,	cfg_cmd_scan,		       	0 },
  { "stayinhost",	10,     cfg_cmd_stayinhost,	       	0 },
  { "nonexists",	9,	cfg_cmd_nonexists,	       	0 },
  { "depth",            5,      cfg_cmd_depth,                  0 },
  { "email",            5,      cfg_cmd_email,                  0 },
  { "auth",	       	4,	cfg_cmd_auth,		       	"http" },
  { "requestline",	11,	cfg_cmd_requestline,		"http" },
  /*  { "addhead",		7,	cfg_cmd_addhead,	       	"http" }, */
  { "ifmodified",	10, cfg_cmd_ifmodified,			"http" },
  { "savehead",		8,	cfg_cmd_savehead,		"http" },
  { "key",	       	3,	cfg_cmd_key,		     	"scan" },
  { "ignore",		6,	cfg_cmd_ignore,		      	"scan" },
  { "diese",		5,	cfg_cmd_diese,		       	"scan" },
  { "skip",	       	4,	cfg_cmd_skip,		       	"scan" },
  { "pattern",		7,	cfg_cmd_pattern,	       	"scan" },
  { "addlog",		6,	log_cfg_addlog,		      	0 },
  { 0,		       	0,  0,			                0 }
};
